## ros-noetic-opw-kinematics 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

# Extract package name and version
find_package(ros_industrial_cmake_boilerplate REQUIRED)
extract_package_metadata(pkg)
project(${pkg_extracted_name} VERSION ${pkg_extracted_version} LANGUAGES CXX)

include(cmake/opw_kinematics_macros.cmake)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

find_package(Eigen3 REQUIRED)
if(NOT EIGEN3_INCLUDE_DIRS)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
endif()

# Load variable for clang tidy args, compiler options and cxx version
opw_variables()

if(NOT MSVC)
  initialize_code_coverage(ENABLE ${OPW_ENABLE_CODE_COVERAGE})
  add_code_coverage_all_targets(ENABLE ${OPW_ENABLE_CODE_COVERAGE})
endif()

# Create interface target
add_library(${PROJECT_NAME} INTERFACE)
target_compile_definitions(${PROJECT_NAME} INTERFACE ${OPW_COMPILE_DEFINITIONS})
target_link_libraries(${PROJECT_NAME} INTERFACE)
target_cxx_version(${PROJECT_NAME} INTERFACE VERSION ${OPW_CXX_VERSION})
target_compile_options(${PROJECT_NAME} INTERFACE ${OPW_COMPILE_OPTIONS_PUBLIC})
target_clang_tidy(${PROJECT_NAME} ENABLE ${OPW_ENABLE_CLANG_TIDY} ARGUMENTS ${OPW_CLANG_TIDY_ARGS})
target_code_coverage(
  ${PROJECT_NAME}
  INTERFACE
  ALL
  ENABLE ${OPW_ENABLE_CODE_COVERAGE})
target_include_directories(${PROJECT_NAME} INTERFACE "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                                                     "$<INSTALL_INTERFACE:include>")
target_include_directories(${PROJECT_NAME} SYSTEM INTERFACE ${EIGEN3_INCLUDE_DIRS})

# Create test executable
add_executable(${PROJECT_NAME}_node src/test.cpp)
target_link_libraries(${PROJECT_NAME}_node PRIVATE ${PROJECT_NAME})
set_target_properties(${PROJECT_NAME}_node PROPERTIES OUTPUT_NAME node PREFIX "")
target_cxx_version(${PROJECT_NAME}_node PRIVATE VERSION ${OPW_CXX_VERSION})
target_compile_options(${PROJECT_NAME}_node PRIVATE ${OPW_COMPILE_OPTIONS_PRIVATE})
target_clang_tidy(${PROJECT_NAME}_node ENABLE ${OPW_ENABLE_CLANG_TIDY})
target_include_what_you_use(${PROJECT_NAME}_node ENABLE ${OPW_ENABLE_TESTING} ARGUMENTS ${DEFAULT_IWYU_ARGS})
target_cppcheck(${PROJECT_NAME}_node ENABLE ${OPW_ENABLE_TESTING} ARGUMENTS ${DEFAULT_CPPCHECK_ARGS})
target_code_coverage(
  ${PROJECT_NAME}_node
  PRIVATE
  ALL
  ENABLE ${OPW_ENABLE_CODE_COVERAGE})

# Install
configure_package(NAMESPACE opw_kinematics TARGETS ${PROJECT_NAME} DEPENDENCIES Eigen3)

# Mark cpp header files for installation
install(
  DIRECTORY include/${PROJECT_NAME}
  DESTINATION include
  FILES_MATCHING
  PATTERN "*.h"
  PATTERN "*.hpp"
  PATTERN "*.hxx"
  PATTERN ".svn" EXCLUDE)

install(FILES "${CMAKE_CURRENT_LIST_DIR}/cmake/opw_kinematics_macros.cmake" DESTINATION lib/cmake/${PROJECT_NAME})

# Testing
if(OPW_ENABLE_TESTING)
  enable_testing()
  add_run_tests_target(ENABLE ${OPW_ENABLE_RUN_TESTING})
  add_subdirectory(test)
endif()

if(OPW_PACKAGE)
  cpack(
    VERSION
    ${pkg_extracted_version}
    MAINTAINER
    <https://github.com/Jmeyer1292/opw_kinematics>
    VENDOR
    "ROS-Industrial"
    DESCRIPTION
    "${PROJECT_NAME}"
    LICENSE_FILE
    ${CMAKE_CURRENT_LIST_DIR}/LICENSE
    README_FILE
    ${CMAKE_CURRENT_LIST_DIR}/Readme.md
    LINUX_DEPENDS
    "libeigen3-dev"
    WINDOWS_DEPENDS
    "Eigen")
endif()

=== test/CMakeLists.txt ===
find_gtest()

macro(opw_add_test name)
  target_cxx_version(${name} PUBLIC VERSION ${OPW_CXX_VERSION})
  target_clang_tidy(${name} ENABLE ${OPW_ENABLE_CLANG_TIDY} ARGUMENTS ${OPW_CLANG_TIDY_ARGS})
  target_include_what_you_use(${name} ENABLE ${OPW_ENABLE_TESTING} ARGUMENTS ${DEFAULT_IWYU_ARGS})
  target_cppcheck(${name} ENABLE ${OPW_ENABLE_TESTING} ARGUMENTS ${DEFAULT_CPPCHECK_ARGS})
  add_gtest_discover_tests(${name})
  add_dependencies(${name} ${PROJECT_NAME})
  add_dependencies(run_tests ${name})

  if(NOT ${GTest_FOUND})
    add_dependencies(${name} GTest ${PROJECT_NAME})
  endif()
endmacro()

# Compares the opw solutions with an ikfast generated for the same robot model
add_executable(${PROJECT_NAME}-test-2400-ikfast abb2400_ikfast_tests.cpp abb_irb2400_manipulator_ikfast_solver.cpp)
target_link_libraries(${PROJECT_NAME}-test-2400-ikfast PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_definitions(${PROJECT_NAME}-test-2400-ikfast PUBLIC -DIKFAST_NO_MAIN -DIKFAST_CLIBRARY
                                                                   -DIKFAST_HAS_LIBRARY)
opw_add_test(${PROJECT_NAME}-test-2400-ikfast)

# Compares a known solution for a robot with varying joint "signs"
add_executable(${PROJECT_NAME}-test-sign-corrections sign_corrections_tests.cpp)
target_link_libraries(${PROJECT_NAME}-test-sign-corrections PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_options(${PROJECT_NAME}-test-sign-corrections PRIVATE ${OPW_COMPILE_OPTIONS_PRIVATE})
opw_add_test(${PROJECT_NAME}-test-sign-corrections)

# Runs tests that iteratively solve FK then IK then confirm the new FK matches Also contains some throughput tests
add_executable(${PROJECT_NAME}-fk-ik fk_ik_tests.cpp)
target_link_libraries(${PROJECT_NAME}-fk-ik PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_options(${PROJECT_NAME}-fk-ik PRIVATE ${OPW_COMPILE_OPTIONS_PRIVATE})
opw_add_test(${PROJECT_NAME}-fk-ik)

=== debian/changelog ===
ros-noetic-opw-kinematics (0.5.0-1focal) focal; urgency=high

  * remove xenial CI build
  * Update to ros_industrial_cmake_boilerplate 0.3.0
  * Contributors: Levi Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Tue, 05 Jul 2022 05:00:00 -0000

ros-noetic-opw-kinematics (0.4.6-1focal) focal; urgency=high

  * Update cpack CI to use colcon
  * Use find_gtest macro
  * Updated CPack
  * Fix windows CI branch
  * Update windows CI (#64 <https://github.com/Jmeyer1292/opw_kinematics/issues/64>)
  * Contributors: Levi Armstrong, Michael Ripperger

 -- Jon Meyer <jmeyer@swri.org>  Sun, 26 Jun 2022 05:00:00 -0000

ros-noetic-opw-kinematics (0.4.5-1focal) focal; urgency=high

  * Upgrade to latest cmake boilerplate and add cmake formater
  * Contributors: Levi Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Thu, 24 Mar 2022 05:00:00 -0000

ros-noetic-opw-kinematics (0.4.4-1focal) focal; urgency=high

  * Fix numerical issue in inverse function
  * Contributors: Levi-Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Thu, 11 Nov 2021 06:00:00 -0000

ros-noetic-opw-kinematics (0.4.3-1focal) focal; urgency=high

  * Do not add compiler option -mno-avx if processor is uknown
  * Contributors: Levi Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Fri, 23 Apr 2021 05:00:00 -0000

ros-noetic-opw-kinematics (0.4.2-1focal) focal; urgency=high

  * Do not add compiler option -mno-avx for arm
  * Contributors: Levi Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Thu, 15 Apr 2021 05:00:00 -0000

ros-noetic-opw-kinematics (0.4.1-1focal) focal; urgency=high

  * Only enable initialize_code_coverage if code coverage is enabled
  * Add cpack archive package
  * Add package debian github action leveraging cpack
  * Add CONTRIBUTING.md
  * Contributors: Levi Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Fri, 09 Apr 2021 05:00:00 -0000

ros-noetic-opw-kinematics (0.4.0-1focal) focal; urgency=high

  * Vectorize using Eigen::Array and Eigen::Map
  * Add code coverage CI build
  * Clean CMakeLists.txt
  * Switch to using std::array versus raw pointer to array
  * Contributors: Levi Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Fri, 19 Feb 2021 06:00:00 -0000

ros-noetic-opw-kinematics (0.3.1-1focal) focal; urgency=high

  * Update to use initialize_code_coverage() macro
  * Contributors: Levi Armstrong

 -- Jon Meyer <jmeyer@swri.org>  Wed, 06 Jan 2021 06:00:00 -0000

ros-noetic-opw-kinematics (0.3.0-1focal) focal; urgency=high

  * Extract package name and version from package.xml
  * Update CI build and add badges to readme
  * Remove -std=c++11 compile option. This causes problems in downstream packages that add cxx_std_14 to compile features.
  * Increase version to 0.2.0
  * Add github actions
  * Add code coverage to targets
  * Add ros_industrial_cmake_boilerplate
  * Contributors: Levi Armstrong, Matthew Powelson

 -- Jon Meyer <jmeyer@swri.org>  Wed, 06 Jan 2021 06:00:00 -0000

ros-noetic-opw-kinematics (0.1.0-1focal) focal; urgency=high

  * Change build tool depend from catkin to cmake
  * Change Affine3d to Isometry3d in readme
  * Address compiler warnings
  * Export targets with namespace to build directory
  * Fix gtest target names
  * Use new source_bat.bash command to set env variables (#34 <https://github.com/Jmeyer1292/opw_kinematics/issues/34>)
    * Use source_bat to configure env variables
    * Update source_bat in travis.yml
    * Update source_bat in travis.yml
    * Remove comments and set build type to Release in travis.yml
  * Add windows build to ci
  * Add package specific gtest subdirectory
  * Initialize Forward return value to identity
  * Fix unit tests method for including gtest to work if exists
  * Pure cmake (#25 <https://github.com/Jmeyer1292/opw_kinematics/issues/25>)
    * Make opw_kinematics a pure cmake package
    * Set cmake version to 3.8.0
    * Add support for cmake versions on xenial
    * Replace cxx property with compiler option
    * Add namespace to exported targets
    * Add ExternalProject_add for GTest if not found
  * force evaluation of Vector u in forward, fixes #21 <https://github.com/Jmeyer1292/opw_kinematics/issues/21>
    using auto here allowed the compiler to create some sort of computation-object that
    was later handled incorrectly. Not sure if this is a bug in Eigen or g++. It also fixes
    a warning about uninitialized values being used and makes the tests succeed on our
    systems.
  * switch to industrial_ci, add eigen dependency
  * accept warnings as they stem from ikfast mostly
  * Add travis config based on moveit_ci
  * Fix printing of joint sign corrections. Print the sign correction as -1 or 1 instead of the raw character.
  * Replaced Affine with Isometry in Readme.md
  * Changed license to Apache 2.0
  * Replaced Affine with Isometry to better reflect what the solver is working toward
  * Added image with positive rotations marked on it
  * Added note about the default rotational axis
  * Added noexcept to IK & FK calls. Casted all real number literals to the appropriate type. This prevents us from converting doubles to floats all the time and increases speed by quite a bit when you want to use floats.
  * Swapped the short int to a signed char. We're just using it for -1 or 1 so it shouldn't matter.
  * Made updates to the attribution for the idea behind the test: thanks jeroen demaeyer!
  * Added a 'throughput' test for FK/IK for three different robots. No assertions but its nice to have something easy to re-run.
  * Added a new set of tests based on JeroenDM's kuka tests that compute FK, solve the IK, and then make sure a new FK matches the original
  * Renames abb2400_tests to abb2400_ikfast_tests to better capture the intent of the tests
  * Moved the gtests inside a CATKIN_ENABLE_TESTING if-clause in the main cmake file
  * Add joint sign corrections to parameters
  * add ik test for using a single forward kinematics solution
  * add simple fk test using a known solution for KukaKR6_R700_sixx


=== debian/control ===
Source: ros-noetic-opw-kinematics
Section: misc
Priority: optional
Maintainer: Jon Meyer <jmeyer@swri.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev, libgtest-dev <!nocheck>, ros-noetic-ros-industrial-cmake-boilerplate
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-opw-kinematics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev
Description: A simple, analytical inverse kinematic library for industrial robots with parallel bases and spherical wrists.
 Based on the paper &quot;An Analytical Solution of the Inverse Kinematics Problem of Industrial Serial Manipulators with an Ortho-parallel Basis and a Spherical Wrist&quot; by Mathias Brandstötter, Arthur Angerer, and Michael Hofbaur.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-opw-kinematics//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-opw-kinematics//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
